//   24.09.2014 11:32 ; Andrej Bugár
//   Kod pre Arduino natacajuci solarny panel na optimalnu polohu
//   Hardware setup: analog pin A0: anoda S panelu
//                   PWM pin 9: zlty/hnedy kabel serva
//                   PWM pin 2: TL2                   
//                   PWM pin 3: TL1
//                   PWM pin 5: TL3
//                   PWM pin 6: TL4
// Zaciatok kodu:




#include <Servo.h>                                                  // Importuje servo kniznicu  
Servo myservo;                                                      // Priradi servu nazov 'myservo'

int uhol;                                                           // Uhol natocenia serva
float napatie;                                                      // Napatie namerane na S paneli
float MAXnapatie;                                                   // Najvacsie napatie zistene z prveho skenu  
float MAXnapatie_2;                                                 // Najvacsie napatie zistene z druheho skenu
int idealUhol;                                                      // Uhol serva pri najvacsom napati z prveho skenu
int idealUhol_2;                                                    // Uhol serva pri najvacsom napati z druhrho skenu 
int finalUhol;                                                      // Uhol zisteny sprimerovanim predchadzajucich dvoch uhlov
int vlastnyUhol;                                                    // Tlacitkami upravovany uhol
byte stupen = 176;                                                  // ASCII kod pre znak '°'
 
 
void setup()                                                        // Prebehne len po nabootovani
{ 
  myservo.attach(9);                                                // Servo pripojene na pin PWM 9
  myservo.write(0);                                                 // Otoci servo na 0°
  Serial.begin(9600);                                               // Spusti seriovu komunikaciu(9600bps)
  pinMode(3, INPUT);                                                // Pin S panelu nastavi na vstup
} 
 
  
void loop()                                                         // Po setupe bezi do nekonecna
{ 
  
  if(digitalRead(3) == 1)                                           // Ak sa stlaci TL1
  {
   myservo.write(0);                                                // Otoci servo na 0°
   delay(800);                                                      // Pocka 800 ms  
   MAXnapatie = 0;                                                  // Nastavi na 0
   Serial.print("");                                                // Vypise novy riadok
   Serial.println("Prvy sken:");                                    // Vypis
   
   for(uhol = 0; uhol < 180; uhol += 1)                             // Uhol 0 bude zvysovat o 7 po 156
   {
    myservo.write(uhol);                                            // Otoci servo na uhol 'uhol'
    delay(10);                                                      // Pocka 25 ms
    napatie = (float) analogRead(A0) * 5.00 / 1023.00 ;             // Trojclenkov vypocita napatie na analogovom pine A0
    
    if(napatie > MAXnapatie)                                        // Ak je namerane napatie vacsie ako predchadzajuce...
    {
     idealUhol = uhol;                                               
     MAXnapatie = napatie;                                          
    }
    
    Serial.print(napatie);                                          // Vypis hodnot...
    Serial.print("V");                                              // ...
    Serial.print(" na ");                                           // ...
    Serial.print(uhol);                                             // ...
    Serial.write(stupen);                                           // ...
    Serial.println("");                                             // ...
     
   }
  
   Serial.println("");                                              // Novy riadok
   Serial.println("Druhy sken:");                                   // 'zacina druhy sken'
   delay(200);                                                      // Pocka 200 ms
   MAXnapatie_2 = 0;                                                // Nastavi na 0
   
    
   for(uhol = 180; uhol > 0; uhol -= 1)                             // Uhol 155 bude zmensovat o 7 po 0
   {                                  
    myservo.write(uhol);                                            // Otoci servo na uhol 'uhol'
    delay(10);                                                      // Pocka 25 ms
    napatie = (float) analogRead(A0) * 5.00 / 1023.00 ;             // Trojclenkov vypocita napatie na analogovom pine A0
    
    if(napatie > MAXnapatie_2)                                      // Ak je namerane napatie vacsie ako predchadzajuce...
    {
     idealUhol_2 = uhol;                                            
     MAXnapatie_2 = napatie;                                        
    }
    
    Serial.print(napatie);                                          // Vypis hodnot...
    Serial.print("V");                                              // ...
    Serial.print(" na ");                                           // ...
    Serial.print(uhol);                                             // ...
    Serial.write(stupen);                                           // ...
    Serial.println("");                                             // ...
   }
  
  delay(200);                                                       // Pocka 200 ms                                                      
  finalUhol = (idealUhol + idealUhol_2) / 2 ;                       // Sprimerovanie uhlov z kazdeho skenu
  myservo.write(finalUhol);                                         // Otoci servo na idealny uhol
  vlastnyUhol = finalUhol;
  Serial.println();                                                 // Vypis...
  Serial.println("------ VYSLEDKY ------");
  Serial.print("Prvy sken:  MAX napatie ");
  Serial.print(MAXnapatie);
  Serial.print(" V na ");
  Serial.print(idealUhol);
  Serial.write(stupen);
  Serial.println();
  Serial.print("Druhy sken: MAX napatie ");
  Serial.print(MAXnapatie_2);
  Serial.print(" V na ");
  Serial.print(idealUhol_2);
  Serial.write(stupen);
  Serial.println();
  Serial.print("Idealny uhol: ");
  Serial.print(finalUhol);
  Serial.write(stupen);
  

  
  
 }
 
 
 
 if( digitalRead(2) == 1)                                           // Ak sa stlaci TL2
 {
  vlastnyUhol++;                                                    // Zvasci o 1
  vlastnyUhol = constrain(vlastnyUhol, 0, 180);                     // Obmedzi na interval < 0; 155 >
  myservo.write(vlastnyUhol);                                       // Otoci servo na uhol 'vlastnyUhol'
  delay(10);                                                        // Pocka 10 ms
 }
  
 
 if( digitalRead(5) == 1)                                           // Ak sa stlaci TL3
 {
  vlastnyUhol--;                                                    // Zmensi o 1
  myservo.write(vlastnyUhol);                                       // Otoci servo na uhol 'vlastnyUhol'
  delay(10);                                                        // Pocka 10 ms
 } 
 
 
 if(digitalRead(6) == 1)                                           // Ak sa stlaci TL4
 {
  myservo.write(finalUhol);                                        // Vrati servo na idealny uhol
  vlastnyUhol = finalUhol; 
 }
  
} 

// Koniec kodu
